﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    partial class EasyDAClientTestBase
    {
        protected void BrowseNodesTest_Basic(
            [NotNull] ServerDescriptor serverDescriptor, 
            [NotNull] DANodeDescriptor parentNodeDescriptor,
            int expectedCount)  // -1 for "unknown"
        {
            TestSection.Arrange();
            TestEnvironment.PrecheckServer(serverDescriptor);
            var client = new EasyDAClient();

            TestSection.Act();
            DANodeElementCollection nodeElements = client.BrowseNodes(
                serverDescriptor,
                parentNodeDescriptor,
                DABrowseParameters.Empty);

            TestSection.Assert();
            Assert.IsNotNull(nodeElements);
            AssertUtilities.WriteLine(nodeElements.Count);
            CollectionAssert.AllItemsAreNotNull(nodeElements);
            foreach (DANodeElement nodeElement in nodeElements)
                AssertUtilities.WriteLine(nodeElement);
            if (expectedCount >= 0)
                Assert.AreEqual(expectedCount, nodeElements.Count);
        }
    }
}
