﻿using System;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.AddressSpace;

namespace OpcLabs.EasyOpcLiveTest.Legacy.DataAccess
{
    // ReSharper disable once InconsistentNaming
    public class IEasyDAClientTest_BrowseNodes : IEasyDAClientTestBase
    {
        public IEasyDAClientTest_BrowseNodes([NotNull] Func<IEasyDAClient> createClientFunc)
            : base(createClientFunc)
        {
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BrowseNodesTest_Root()
        {
            var target = CreateClient();

            DANodeElementCollection actualResultCollection = target.BrowseNodes(
                new ServerDescriptor(LegacyTestDefs.ProgIds.KitServer), 
                DANodeDescriptor.Root, 
                DABrowseParameters.Empty);

            Assert.IsNotNull(actualResultCollection);
            int count = actualResultCollection.Count;
            Assert.IsTrue(count >= 7);

            //TODO:
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BrowseNodesTest_Simulation()
        {
            var target = CreateClient();

            DANodeElementCollection actualResultCollection = target.BrowseNodes(
                new ServerDescriptor(LegacyTestDefs.ProgIds.KitServer),
                new DANodeDescriptor("Simulation"),
                DABrowseParameters.Empty);

            Assert.IsNotNull(actualResultCollection);
            int count = actualResultCollection.Count;
            Assert.IsTrue(count >= 163);

            //TODO:
        }
    }
}
