﻿using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA
{
    public partial class EasyUAClientTest
    {
        public partial class Endpoint
        {
            #region Test Methods

            [TestCategory("Live")]
            [TestCategory("Load")]
            [TestCategory("OpcUA")]
            [TestCategory("TimeDomain")]
            [TestMethod]
            public void SubscribeMonitoredItemTest_Load_NodeCount_20()
            {
                var tester = new SubscribeLoadTester(EndpointDescriptor, useMultiple: false, nodeCount: 20);
                tester.Test();
            }

            [TestCategory("Live")]
            [TestCategory("Load")]
            [TestCategory("OpcUA")]
            [TestCategory("TimeDomain")]
            [TestMethod]
            public void SubscribeMonitoredItemTest_Load_NodeCount_20_DelayBetweenSubscribes_100()
            {
                var tester = new SubscribeLoadTester(EndpointDescriptor, useMultiple: false, nodeCount: 20, duration: 10*1000, delayBetweenSubscribes: 500);
                tester.Test();
            }

            [TestCategory("Live")]
            [TestCategory("Load")]
            [TestCategory("OpcUA")]
            [TestCategory("TimeDomain")]
            [TestMethod]
            public void SubscribeMonitoredItemTest_Load_NodeCount_20_DelayBetweenSubscribes_500()
            {
                var tester = new SubscribeLoadTester(EndpointDescriptor, useMultiple: false, nodeCount: 20, duration: 10 * 1000, delayBetweenSubscribes: 500);
                tester.Test();
            }

            /// <summary>
            /// QOUA-NOTE 448. SmartSubscription: If we subscribe from more client objects, don’t we merge subscriptions and get 
            /// notifications for all (including foreign) objects?
            /// </summary>
            [TestCategory("Live")]
            [TestCategory("OpcUA")]
            [TestCategory("TimeDomain")]
            [TestMethod]
            public void SubscribeMonitoredItemTest_Separation()
            {
                var tester = new SeparationTester();
                tester.Test();
            }

            [TestCategory("Live")]
            [TestCategory("Load")]
            [TestCategory("OpcUA")]
            [TestCategory("TimeDomain")]
            [TestMethod]
            public void SubscribeMultipleMonitoredItemsTest_Load_NodeCount_20()
            {
                var tester = new SubscribeLoadTester(EndpointDescriptor, useMultiple: true, nodeCount: 20);
                tester.Test();
            }

            [TestCategory("Live")]
            [TestCategory("Load")]
            [TestCategory("OpcUA")]
            [TestCategory("TimeDomain")]
            [TestMethod]
            public void SubscribeMultipleMonitoredItemsTest_Load_NodeCount_393()
            {
                var tester = new SubscribeLoadTester(EndpointDescriptor, useMultiple: true, nodeCount: 393);
                tester.Test();
            }

            #endregion
        }
    }
}
