﻿
using System.Collections.Generic;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment
{
    // ReSharper disable once InconsistentNaming
    public class Softing_OpcUaNetDemoServer : UAServer
    {
        public class EndpointDescriptorsInfo
        {
            public EndpointDescriptorsInfo([NotNull] Softing_OpcUaNetDemoServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public UAEndpointDescriptor Http => new UAEndpointDescriptor(_parent._endpointUrlStrings.Http);

            [NotNull]
            public UAEndpointDescriptor Https => new UAEndpointDescriptor(_parent._endpointUrlStrings.Https);

            [NotNull]
            public UAEndpointDescriptor OpcTcp => new UAEndpointDescriptor(_parent._endpointUrlStrings.OpcTcp);

            [NotNull]
            private readonly Softing_OpcUaNetDemoServer _parent;
        }



        private class EndpointUrlStringsInfo
        {
            public EndpointUrlStringsInfo([NotNull] Softing_OpcUaNetDemoServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public string Http => "http://" + _parent.HostName + ":51511/UA/DemoServer";
            [NotNull]
            public string Https => "https://" + _parent.HostName + ":51512/UA/DemoServer/";
            [NotNull]
            public string OpcTcp => "opc.tcp://" + _parent.HostName + ":51510/UA/DemoServer";

            [NotNull]
            private readonly Softing_OpcUaNetDemoServer _parent;
        }



        public Softing_OpcUaNetDemoServer([NotNull] string hostName)
            : base(hostName)
        {
            EndpointDescriptors = new EndpointDescriptorsInfo(this);
            _endpointUrlStrings = new EndpointUrlStringsInfo(this);
        }

        public override IEnumerable<UAEndpointDescriptor> AllEndpointDescriptors
        {
            get
            {
                yield return EndpointDescriptors.OpcTcp;
                yield return EndpointDescriptors.Http;
                yield return EndpointDescriptors.Https;
            }
        }

        [NotNull]
        public readonly EndpointDescriptorsInfo EndpointDescriptors;

        [NotNull]
        private readonly EndpointUrlStringsInfo _endpointUrlStrings;
    }
}
