﻿
using System;
using System.Reactive.Linq;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Reactive;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.UA.Reactive
{
    [TestClass]
    public class UAWriteValueObserverTest
    {
        #region Test Methods

        [TestCategory("OpcUA")]
        [TestMethod]
        public void SimpleTest()
        {
            TestSection.Arrange();
            UAEndpointDescriptor endpointDescriptor = UATestEnvironment.OpcFoundation_UASampleServer.EndpointDescriptors.Https;
            TestEnvironment.PrecheckEndpoint(endpointDescriptor);

            var observer = UAWriteValueObserver.Create<int>(
                endpointDescriptor,
                "nsu=http://test.org/UA/Data/;i=10389");

            TestSection.Act();
            // ReSharper disable once PossibleNullReferenceException
            Observable
                .Interval(TimeSpan.FromSeconds(0.5))
                .Select(l => (int)l)
                .Subscribe(observer);

            AssertUtilities.WaitingPhase(10*1000);

            TestSection.Assert();
        }

        #endregion



        #region Private Properties

        [NotNull]
        private UATestEnvironment TestEnvironment => UATestEnvironment.Current;

        #endregion
    }
}
