﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.ComInterop;
using OpcLabs.EasyOpc.AlarmsAndEvents.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.AlarmsAndEvents.AddressSpace
{
    public partial class AEAttributeElementTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("XmlSerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("XmlSerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        public AEAttributeElement CreateSerializationTarget0()
        {
            return new AEAttributeElement();
        }

        [NotNull]
        public AEAttributeElement CreateSerializationTarget1()
        {
            return new AEAttributeElement
            {
                AttributeId = 111,
                DataType = VarTypes.Bool,
                Description = "TestDescription1"
            };
        }

        [NotNull]
        public AEAttributeElement CreateSerializationTarget2()
        {
            return new AEAttributeElement
            {
                AttributeId = 222,
                DataType = VarTypes.Bool,
                Description = "TestDescription2"
            };
        }
    }
}
