﻿
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Execution;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.AlarmsAndEvents
{
    partial class EasyAEClientTest
    {
        [Ignore]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void ChangeSomeSharedParameterTest()
        {
            int oldValue = EasyAEClient.SharedParameters.EngineParameters.ClientLruSize;
            AssertUtilities.WriteLine(oldValue);
            using (new StaticEnvironment())
            {
                int newValue = oldValue ^ 1;
                AssertUtilities.WriteLine(newValue);
                EasyAEClient.SharedParameters.EngineParameters.ClientLruSize = newValue;
                Assert.AreEqual(newValue, EasyAEClient.SharedParameters.EngineParameters.ClientLruSize);

                // do some operation
                AEConditionState conditionState = new EasyAEClient().GetConditionState("", "aServer",
                    "Simulation.ConditionState1", "Simulated");
                AssertUtilities.WriteLine(conditionState);
            }
            Assert.AreEqual(oldValue, EasyAEClient.SharedParameters.EngineParameters.ClientLruSize);
        }
    }
}
