﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.DataTypeModel;
using OpcLabs.EasyOpc.UA.DataTypeModel;

namespace OpcLabs.EasyOpcTest.UA.DataTypeModel.Internal
{
    partial class DeveloperTest
    {
        #region Static Private Properties

        [NotNull]
        static private StructuredDataType IntegerArrayWithFixedLengthDataType => new StructuredDataType("IntegerArrayWithFixedLength", "DeveloperTest:IntegerArrayWithFixedLength")
        {
            new DataField("Array", new SequenceDataType(3, UAOpcBinaryStandardDataTypes.Int32))
        };

        [NotNull]
        static private StructuredData IntegerArrayWithFixedLength_2Data => new StructuredData(IntegerArrayWithFixedLengthDataType)
        {
            {
                "Array", new SequenceData/*(new SequenceDataType(UAOpcBinaryStandardDataTypes.Int32, 3))*/
                {
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 161),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 162)
                }
            }
        };

        [NotNull]
        static private StructuredData IntegerArrayWithFixedLength_3Data => new StructuredData(IntegerArrayWithFixedLengthDataType)
        {
            {
                "Array", new SequenceData(new SequenceDataType(3, UAOpcBinaryStandardDataTypes.Int32))
                {
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 161),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 162),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 163)
                }
            }
        };

        [NotNull]
        static private byte[] IntegerArrayWithFixedLength_3ExtensionObjectBody => new byte[]
            {161, 0, 0, 0, 162, 0, 0, 0, 163, 0, 0, 0};

        #endregion



        #region Test Methods

        [TestMethod]
        public void DecodeTest_IntegerArrayWithFixedLength() =>
            DecodeTest(null,
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLength",
                IntegerArrayWithFixedLength_3ExtensionObjectBody,
                IntegerArrayWithFixedLength_3Data);

        [TestMethod]
        public void EncodeTest_IntegerArrayWithFixedLength() =>
            EncodeTest(null,
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLength",
                IntegerArrayWithFixedLength_3Data,
                IntegerArrayWithFixedLength_3ExtensionObjectBody);

        #endregion
    }
}
