﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.EasyOpcFactory.UA;
using OpcLabs.EasyOpcFactory.UA.OperationModel;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.OperationModel
{
    public partial class UAMonitoredItemArgumentsTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        static public UAMonitoredItemArguments CreateSerializationTarget0()
        {
            return new UAMonitoredItemArguments();
        }

        [NotNull]
        static public UAMonitoredItemArguments CreateSerializationTarget1()
        {
            return new UAMonitoredItemArguments(UAAttributeArgumentsInstances.Instance1)
                {
                    MonitoringParameters = UAMonitoringParametersInstances.Instance1,
                    SubscriptionParameters = UASubscriptionParametersInstances.Instance1,
                };
        }
    }
}
