﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class InductiveAutomation_EclipseMiloOpcUAServerSdk_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[]
        {
            "nsu=urn:industrialsoftworks:opcua:server:demo ;ns=2;s=CTT/Static/All Profiles/Array/Int32Array"
        };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[]
        {
            "nsu=urn:industrialsoftworks:opcua:server:demo ;ns=2;s=CTT/Static/All Profiles/Array/Int32Array"
        };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:industrialsoftworks:opcua:server:demo ;ns=2;s=Dynamic/RandomDouble",
            "nsu=urn:industrialsoftworks:opcua:server:demo ;ns=2;s=Dynamic/RandomFloat"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[]
            {"opc.tcp://192.168.1.32:62541/milo/discovery"};

        //public override int InterSessionDelay => 2000;

        public override string Password => "password";

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test01_CreateSession_UaTcp_None),
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group005_InformationModel_Test04_Browse_Read_SessionDiagnosticsArray),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            //nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            //nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            //nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "nsu=urn:industrialsoftworks:opcua:server:demo ;ns=2;s=CTT/Static/All Profiles/Scalar/Int32",
            "nsu=urn:industrialsoftworks:opcua:server:demo ;ns=2;s=CTT/Static/All Profiles/Scalar/Double"
        };

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[]
        {
            "nsu=urn:industrialsoftworks:opcua:server:demo ;ns=2;s=CTT/Static/All Profiles/Scalar/Int32",
            "nsu=urn:industrialsoftworks:opcua:server:demo ;ns=2;s=CTT/Static/All Profiles/Scalar/Double"
        };

        public override string UserName => "user1";
    }
}
